#!/usr/bin/perl
# Perl script to display output from dmesg command (print kernel ring buffer)
# in fancy way with date-time in output like the default logfiles.
# -------------------------------------------------------------------------
# Copyright (c) 2021 R.W.H. Vermare <rene(at)vermare(dot)net>
# This script is licensed under GNU GPL version 2.0 or above
# Version 1.1 (june 2021)
# -------------------------------------------------------------------------
# This script is part of the Doctor Linux collection
# -------------------------------------------------------------------------
 
use strict;
use warnings;
  
my @dmesg_new = ();
my $dmesg = "/bin/dmesg";
my @dmesg_old = `$dmesg`;
my $now = time();
my $uptime = `cat /proc/uptime | cut -d"." -f1`;
my $t_now = $now - $uptime;
   
sub format_time {
 my @time = localtime $_[0];
 $time[4]+=1;    # Adjust Month
 $time[5]+=1900;    # Adjust Year
 return sprintf '%4i-%02i-%02i %02i:%02i:%02i', @time[reverse 0..5];
}
        
foreach my $line ( @dmesg_old )
{
  chomp( $line );
  if( $line =~ m/\[\s*(\d+)\.(\d+)\](.*)/i )
  {
# now - uptime + seconds
my $t_time = format_time( $t_now + $1 );
push( @dmesg_new , "[$t_time] $3" );
     }
}
                
print join( "\n", @dmesg_new );
print "\n";
